package ens

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeWorkflowActivity invokes the ens.DescribeWorkflowActivity API synchronously
func (client *Client) DescribeWorkflowActivity(request *DescribeWorkflowActivityRequest) (response *DescribeWorkflowActivityResponse, err error) {
	response = CreateDescribeWorkflowActivityResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeWorkflowActivityWithChan invokes the ens.DescribeWorkflowActivity API asynchronously
func (client *Client) DescribeWorkflowActivityWithChan(request *DescribeWorkflowActivityRequest) (<-chan *DescribeWorkflowActivityResponse, <-chan error) {
	responseChan := make(chan *DescribeWorkflowActivityResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeWorkflowActivity(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeWorkflowActivityWithCallback invokes the ens.DescribeWorkflowActivity API asynchronously
func (client *Client) DescribeWorkflowActivityWithCallback(request *DescribeWorkflowActivityRequest, callback func(response *DescribeWorkflowActivityResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeWorkflowActivityResponse
		var err error
		defer close(result)
		response, err = client.DescribeWorkflowActivity(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeWorkflowActivityRequest is the request struct for api DescribeWorkflowActivity
type DescribeWorkflowActivityRequest struct {
	*requests.RpcRequest
	WorkFlowId string `position:"Query" name:"WorkFlowId"`
}

// DescribeWorkflowActivityResponse is the response struct for api DescribeWorkflowActivity
type DescribeWorkflowActivityResponse struct {
	*responses.BaseResponse
	RequestId    string          `json:"RequestId" xml:"RequestId"`
	ActivityInfo []ActivityInfos `json:"ActivityInfo" xml:"ActivityInfo"`
}

// CreateDescribeWorkflowActivityRequest creates a request to invoke DescribeWorkflowActivity API
func CreateDescribeWorkflowActivityRequest() (request *DescribeWorkflowActivityRequest) {
	request = &DescribeWorkflowActivityRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Ens", "2017-11-10", "DescribeWorkflowActivity", "ens", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeWorkflowActivityResponse creates a response to parse from DescribeWorkflowActivity response
func CreateDescribeWorkflowActivityResponse() (response *DescribeWorkflowActivityResponse) {
	response = &DescribeWorkflowActivityResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
