package mns_open

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ListSubscriptionByTopic invokes the mns_open.ListSubscriptionByTopic API synchronously
func (client *Client) ListSubscriptionByTopic(request *ListSubscriptionByTopicRequest) (response *ListSubscriptionByTopicResponse, err error) {
	response = CreateListSubscriptionByTopicResponse()
	err = client.DoAction(request, response)
	return
}

// ListSubscriptionByTopicWithChan invokes the mns_open.ListSubscriptionByTopic API asynchronously
func (client *Client) ListSubscriptionByTopicWithChan(request *ListSubscriptionByTopicRequest) (<-chan *ListSubscriptionByTopicResponse, <-chan error) {
	responseChan := make(chan *ListSubscriptionByTopicResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ListSubscriptionByTopic(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ListSubscriptionByTopicWithCallback invokes the mns_open.ListSubscriptionByTopic API asynchronously
func (client *Client) ListSubscriptionByTopicWithCallback(request *ListSubscriptionByTopicRequest, callback func(response *ListSubscriptionByTopicResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ListSubscriptionByTopicResponse
		var err error
		defer close(result)
		response, err = client.ListSubscriptionByTopic(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ListSubscriptionByTopicRequest is the request struct for api ListSubscriptionByTopic
type ListSubscriptionByTopicRequest struct {
	*requests.RpcRequest
	SubscriptionName string           `position:"Query" name:"SubscriptionName"`
	TopicName        string           `position:"Query" name:"TopicName"`
	PageNum          requests.Integer `position:"Query" name:"PageNum"`
	PageSize         requests.Integer `position:"Query" name:"PageSize"`
}

// ListSubscriptionByTopicResponse is the response struct for api ListSubscriptionByTopic
type ListSubscriptionByTopicResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Code      int64  `json:"Code" xml:"Code"`
	Status    string `json:"Status" xml:"Status"`
	Message   string `json:"Message" xml:"Message"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateListSubscriptionByTopicRequest creates a request to invoke ListSubscriptionByTopic API
func CreateListSubscriptionByTopicRequest() (request *ListSubscriptionByTopicRequest) {
	request = &ListSubscriptionByTopicRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Mns-open", "2022-01-19", "ListSubscriptionByTopic", "mns", "openAPI")
	request.Method = requests.POST
	return
}

// CreateListSubscriptionByTopicResponse creates a response to parse from ListSubscriptionByTopic response
func CreateListSubscriptionByTopicResponse() (response *ListSubscriptionByTopicResponse) {
	response = &ListSubscriptionByTopicResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
