package paifeaturestore

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateModelFeatureFGInfo invokes the paifeaturestore.UpdateModelFeatureFGInfo API synchronously
func (client *Client) UpdateModelFeatureFGInfo(request *UpdateModelFeatureFGInfoRequest) (response *UpdateModelFeatureFGInfoResponse, err error) {
	response = CreateUpdateModelFeatureFGInfoResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateModelFeatureFGInfoWithChan invokes the paifeaturestore.UpdateModelFeatureFGInfo API asynchronously
func (client *Client) UpdateModelFeatureFGInfoWithChan(request *UpdateModelFeatureFGInfoRequest) (<-chan *UpdateModelFeatureFGInfoResponse, <-chan error) {
	responseChan := make(chan *UpdateModelFeatureFGInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateModelFeatureFGInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateModelFeatureFGInfoWithCallback invokes the paifeaturestore.UpdateModelFeatureFGInfo API asynchronously
func (client *Client) UpdateModelFeatureFGInfoWithCallback(request *UpdateModelFeatureFGInfoRequest, callback func(response *UpdateModelFeatureFGInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateModelFeatureFGInfoResponse
		var err error
		defer close(result)
		response, err = client.UpdateModelFeatureFGInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateModelFeatureFGInfoRequest is the request struct for api UpdateModelFeatureFGInfo
type UpdateModelFeatureFGInfoRequest struct {
	*requests.RoaRequest
	ModelFeatureId string `position:"Path" name:"ModelFeatureId"`
	Body           string `position:"Body" name:"body"`
	InstanceId     string `position:"Path" name:"InstanceId"`
}

// UpdateModelFeatureFGInfoResponse is the response struct for api UpdateModelFeatureFGInfo
type UpdateModelFeatureFGInfoResponse struct {
	*responses.BaseResponse
	RequestId string `json:"requestId" xml:"requestId"`
}

// CreateUpdateModelFeatureFGInfoRequest creates a request to invoke UpdateModelFeatureFGInfo API
func CreateUpdateModelFeatureFGInfoRequest() (request *UpdateModelFeatureFGInfoRequest) {
	request = &UpdateModelFeatureFGInfoRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("PaiFeatureStore", "2023-06-21", "UpdateModelFeatureFGInfo", "/api/v1/instances/[InstanceId]/modelfeatures/[ModelFeatureId]/fginfo", "", "")
	request.Method = requests.PUT
	return
}

// CreateUpdateModelFeatureFGInfoResponse creates a response to parse from UpdateModelFeatureFGInfo response
func CreateUpdateModelFeatureFGInfoResponse() (response *UpdateModelFeatureFGInfoResponse) {
	response = &UpdateModelFeatureFGInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
