package ververica

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// UpdateDeploymentDesiredState invokes the ververica.UpdateDeploymentDesiredState API synchronously
func (client *Client) UpdateDeploymentDesiredState(request *UpdateDeploymentDesiredStateRequest) (response *UpdateDeploymentDesiredStateResponse, err error) {
	response = CreateUpdateDeploymentDesiredStateResponse()
	err = client.DoAction(request, response)
	return
}

// UpdateDeploymentDesiredStateWithChan invokes the ververica.UpdateDeploymentDesiredState API asynchronously
func (client *Client) UpdateDeploymentDesiredStateWithChan(request *UpdateDeploymentDesiredStateRequest) (<-chan *UpdateDeploymentDesiredStateResponse, <-chan error) {
	responseChan := make(chan *UpdateDeploymentDesiredStateResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.UpdateDeploymentDesiredState(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// UpdateDeploymentDesiredStateWithCallback invokes the ververica.UpdateDeploymentDesiredState API asynchronously
func (client *Client) UpdateDeploymentDesiredStateWithCallback(request *UpdateDeploymentDesiredStateRequest, callback func(response *UpdateDeploymentDesiredStateResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *UpdateDeploymentDesiredStateResponse
		var err error
		defer close(result)
		response, err = client.UpdateDeploymentDesiredState(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// UpdateDeploymentDesiredStateRequest is the request struct for api UpdateDeploymentDesiredState
type UpdateDeploymentDesiredStateRequest struct {
	*requests.RoaRequest
	Workspace    string `position:"Path" name:"workspace"`
	ParamsJson   string `position:"Body" name:"paramsJson"`
	DeploymentId string `position:"Path" name:"deploymentId"`
	Namespace    string `position:"Path" name:"namespace"`
}

// UpdateDeploymentDesiredStateResponse is the response struct for api UpdateDeploymentDesiredState
type UpdateDeploymentDesiredStateResponse struct {
	*responses.BaseResponse
	Success   bool   `json:"success" xml:"success"`
	RequestId string `json:"requestId" xml:"requestId"`
	Data      string `json:"data" xml:"data"`
}

// CreateUpdateDeploymentDesiredStateRequest creates a request to invoke UpdateDeploymentDesiredState API
func CreateUpdateDeploymentDesiredStateRequest() (request *UpdateDeploymentDesiredStateRequest) {
	request = &UpdateDeploymentDesiredStateRequest{
		RoaRequest: &requests.RoaRequest{},
	}
	request.InitWithApiInfo("ververica", "2020-05-01", "UpdateDeploymentDesiredState", "/pop/workspaces/[workspace]/api/v1/namespaces/[namespace]/deployments/[deploymentId]/state", "", "")
	request.Method = requests.PUT
	return
}

// CreateUpdateDeploymentDesiredStateResponse creates a response to parse from UpdateDeploymentDesiredState response
func CreateUpdateDeploymentDesiredStateResponse() (response *UpdateDeploymentDesiredStateResponse) {
	response = &UpdateDeploymentDesiredStateResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
